##// END OF EJS Templates
fix
Unknown -
r418:3196cb67b2c7
parent child
Show More
@@ -1,817 +1,811
1 #!/bin/sh
1 #!/bin/sh
2 ########################################################################
2 ########################################################################
3 # rpi23-gen-image.sh 2015-2017
3 # rpi23-gen-image.sh 2015-2017
4 #
4 #
5 # Advanced Debian "stretch" and "buster" bootstrap script for RPi2/3
5 # Advanced Debian "stretch" and "buster" bootstrap script for RPi2/3
6 #
6 #
7 # This program is free software; you can redistribute it and/or
7 # This program is free software; you can redistribute it and/or
8 # modify it under the terms of the GNU General Public License
8 # modify it under the terms of the GNU General Public License
9 # as published by the Free Software Foundation; either version 2
9 # as published by the Free Software Foundation; either version 2
10 # of the License, or (at your option) any later version.
10 # of the License, or (at your option) any later version.
11 #
11 #
12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 #
13 #
14 # Big thanks for patches and enhancements by 20+ github contributors!
14 # Big thanks for patches and enhancements by 20+ github contributors!
15 ########################################################################
15 ########################################################################
16
16
17 # Are we running as root?
17 # Are we running as root?
18 if [ "$(id -u)" -ne "0" ] ; then
18 if [ "$(id -u)" -ne "0" ] ; then
19 echo "error: this script must be executed with root privileges!"
19 echo "error: this script must be executed with root privileges!"
20 exit 1
20 exit 1
21 fi
21 fi
22
22
23 # Check if ./functions.sh script exists
23 # Check if ./functions.sh script exists
24 if [ ! -r "./functions.sh" ] ; then
24 if [ ! -r "./functions.sh" ] ; then
25 echo "error: './functions.sh' required script not found!"
25 echo "error: './functions.sh' required script not found!"
26 exit 1
26 exit 1
27 fi
27 fi
28
28
29 # Load utility functions
29 # Load utility functions
30 . ./functions.sh
30 . ./functions.sh
31
31
32 # Load parameters from configuration template file
32 # Load parameters from configuration template file
33 if [ -n "$CONFIG_TEMPLATE" ] ; then
33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 use_template
34 use_template
35 fi
35 fi
36
36
37 # Introduce settings
37 # Introduce settings
38 set -e
38 set -e
39 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
39 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
40 set -x
40 set -x
41
41
42 # Raspberry Pi model configuration
42 # Raspberry Pi model configuration
43 RPI_MODEL=${RPI_MODEL:=2}
43 RPI_MODEL=${RPI_MODEL:=2}
44
44
45 # Debian release
45 # Debian release
46 RELEASE=${RELEASE:=buster}
46 RELEASE=${RELEASE:=buster}
47
47
48 #Kernel Branch
48 #Kernel Branch
49 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
49 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
50
50
51 # URLs
51 # URLs
52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
55 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
55 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
56 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
56 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
57 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
57 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
58 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
58 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
59 #BIS= Kernel has KVM and zswap enabled
59 #BIS= Kernel has KVM and zswap enabled
60 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
60 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
61 #default bcmrpi3_defconfig target kernel
61 #default bcmrpi3_defconfig target kernel
62 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
62 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
63 #enhanced kernel
63 #enhanced kernel
64 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_BIS_KERNEL_URL}
64 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_BIS_KERNEL_URL}
65 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
65 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
66
66
67 # Build directories
67 # Build directories
68 WORKDIR=$(pwd)
68 WORKDIR=$(pwd)
69 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
69 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
70 BUILDDIR="${BASEDIR}/build"
70 BUILDDIR="${BASEDIR}/build"
71
71
72 # Prepare date string for default image file name
73 DATE="$(date +%Y-%m-%d)"
74 if [ -z "$KERNEL_BRANCH" ] ; then
75 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
76 else
77 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
78 fi
79
80 # Chroot directories
72 # Chroot directories
81 R="${BUILDDIR}/chroot"
73 R="${BUILDDIR}/chroot"
82 ETC_DIR="${R}/etc"
74 ETC_DIR="${R}/etc"
83 LIB_DIR="${R}/lib"
75 LIB_DIR="${R}/lib"
84 BOOT_DIR="${R}/boot/firmware"
76 BOOT_DIR="${R}/boot/firmware"
85 KERNEL_DIR="${R}/usr/src/linux"
77 KERNEL_DIR="${R}/usr/src/linux"
86 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
78 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
87
79
88 # Firmware directory: Blank if download from github
80 # Firmware directory: Blank if download from github
89 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
81 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
90
82
91 # General settings
83 # General settings
92 SET_ARCH=${SET_ARCH:=32}
84 SET_ARCH=${SET_ARCH:=32}
93 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
85 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
94 PASSWORD=${PASSWORD:=raspberry}
86 PASSWORD=${PASSWORD:=raspberry}
95 USER_PASSWORD=${USER_PASSWORD:=raspberry}
87 USER_PASSWORD=${USER_PASSWORD:=raspberry}
96 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
88 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
97 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
89 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
98 EXPANDROOT=${EXPANDROOT:=true}
90 EXPANDROOT=${EXPANDROOT:=true}
99
91
100 # Keyboard settings
92 # Keyboard settings
101 XKB_MODEL=${XKB_MODEL:=""}
93 XKB_MODEL=${XKB_MODEL:=""}
102 XKB_LAYOUT=${XKB_LAYOUT:=""}
94 XKB_LAYOUT=${XKB_LAYOUT:=""}
103 XKB_VARIANT=${XKB_VARIANT:=""}
95 XKB_VARIANT=${XKB_VARIANT:=""}
104 XKB_OPTIONS=${XKB_OPTIONS:=""}
96 XKB_OPTIONS=${XKB_OPTIONS:=""}
105
97
106 # Network settings (DHCP)
98 # Network settings (DHCP)
107 ENABLE_DHCP=${ENABLE_DHCP:=true}
99 ENABLE_DHCP=${ENABLE_DHCP:=true}
108
100
109 # Network settings (static)
101 # Network settings (static)
110 NET_ADDRESS=${NET_ADDRESS:=""}
102 NET_ADDRESS=${NET_ADDRESS:=""}
111 NET_GATEWAY=${NET_GATEWAY:=""}
103 NET_GATEWAY=${NET_GATEWAY:=""}
112 NET_DNS_1=${NET_DNS_1:=""}
104 NET_DNS_1=${NET_DNS_1:=""}
113 NET_DNS_2=${NET_DNS_2:=""}
105 NET_DNS_2=${NET_DNS_2:=""}
114 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
106 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
115 NET_NTP_1=${NET_NTP_1:=""}
107 NET_NTP_1=${NET_NTP_1:=""}
116 NET_NTP_2=${NET_NTP_2:=""}
108 NET_NTP_2=${NET_NTP_2:=""}
117
109
118 # APT settings
110 # APT settings
119 APT_PROXY=${APT_PROXY:=""}
111 APT_PROXY=${APT_PROXY:=""}
120 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
112 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
121
113
122 # Feature settings
114 # Feature settings
123 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
115 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
124 ENABLE_I2C=${ENABLE_I2C:=false}
116 ENABLE_I2C=${ENABLE_I2C:=false}
125 ENABLE_SPI=${ENABLE_SPI:=false}
117 ENABLE_SPI=${ENABLE_SPI:=false}
126 ENABLE_IPV6=${ENABLE_IPV6:=true}
118 ENABLE_IPV6=${ENABLE_IPV6:=true}
127 ENABLE_SSHD=${ENABLE_SSHD:=true}
119 ENABLE_SSHD=${ENABLE_SSHD:=true}
128 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
120 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
129 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
121 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
130 ENABLE_SOUND=${ENABLE_SOUND:=true}
122 ENABLE_SOUND=${ENABLE_SOUND:=true}
131 ENABLE_DBUS=${ENABLE_DBUS:=true}
123 ENABLE_DBUS=${ENABLE_DBUS:=true}
132 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
124 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
133 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
125 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
134 ENABLE_XORG=${ENABLE_XORG:=false}
126 ENABLE_XORG=${ENABLE_XORG:=false}
135 ENABLE_WM=${ENABLE_WM:=""}
127 ENABLE_WM=${ENABLE_WM:=""}
136 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
128 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
137 ENABLE_USER=${ENABLE_USER:=true}
129 ENABLE_USER=${ENABLE_USER:=true}
138 USER_NAME=${USER_NAME:="pi"}
130 USER_NAME=${USER_NAME:="pi"}
139 ENABLE_ROOT=${ENABLE_ROOT:=false}
131 ENABLE_ROOT=${ENABLE_ROOT:=false}
140 ENABLE_QEMU=${ENABLE_QEMU:=false}
132 ENABLE_QEMU=${ENABLE_QEMU:=false}
141 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
133 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
142
134
143 # SSH settings
135 # SSH settings
144 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
136 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
145 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
137 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
146 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
138 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
147 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
139 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
148 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
140 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
149
141
150 # Advanced settings
142 # Advanced settings
151 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
143 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
152 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
144 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
153 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
145 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
154 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
146 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
155 ENABLE_UBOOTUSB=${ENABLE_UBOOTUSB=false}
147 ENABLE_UBOOTUSB=${ENABLE_UBOOTUSB=false}
156 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
148 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
157 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=true}
149 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=true}
158 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
150 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
159 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
151 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
160 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
152 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
161 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
153 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
162 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
154 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
163 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
155 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
164 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
156 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
165 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
157 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
166
158
167 # Kernel compilation settings
159 # Kernel compilation settings
168 BUILD_KERNEL=${BUILD_KERNEL:=true}
160 BUILD_KERNEL=${BUILD_KERNEL:=true}
169 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
161 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
170 KERNEL_THREADS=${KERNEL_THREADS:=1}
162 KERNEL_THREADS=${KERNEL_THREADS:=1}
171 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
163 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
172 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
164 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
173 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
165 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
174 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
166 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
175 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
167 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
176 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
168 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
177 KERNEL_VIRT=${KERNEL_VIRT:=false}
169 KERNEL_VIRT=${KERNEL_VIRT:=false}
178 KERNEL_BPF=${KERNEL_BPF:=false}
170 KERNEL_BPF=${KERNEL_BPF:=false}
179
171
180 # Kernel compilation from source directory settings
172 # Kernel compilation from source directory settings
181 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
173 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
182 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
174 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
183 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
175 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
184 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
176 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
185
177
186 # Reduce disk usage settings
178 # Reduce disk usage settings
187 REDUCE_APT=${REDUCE_APT:=true}
179 REDUCE_APT=${REDUCE_APT:=true}
188 REDUCE_DOC=${REDUCE_DOC:=true}
180 REDUCE_DOC=${REDUCE_DOC:=true}
189 REDUCE_MAN=${REDUCE_MAN:=true}
181 REDUCE_MAN=${REDUCE_MAN:=true}
190 REDUCE_VIM=${REDUCE_VIM:=false}
182 REDUCE_VIM=${REDUCE_VIM:=false}
191 REDUCE_BASH=${REDUCE_BASH:=false}
183 REDUCE_BASH=${REDUCE_BASH:=false}
192 REDUCE_HWDB=${REDUCE_HWDB:=true}
184 REDUCE_HWDB=${REDUCE_HWDB:=true}
193 REDUCE_SSHD=${REDUCE_SSHD:=true}
185 REDUCE_SSHD=${REDUCE_SSHD:=true}
194 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
186 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
195
187
196 # Encrypted filesystem settings
188 # Encrypted filesystem settings
197 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
189 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
198 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
190 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
199 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
191 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
200 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
192 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
201 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
193 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
202
194
203 # Chroot scripts directory
195 # Chroot scripts directory
204 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
196 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
205
197
206 # Packages required in the chroot build environment
198 # Packages required in the chroot build environment
207 APT_INCLUDES=${APT_INCLUDES:=""}
199 APT_INCLUDES=${APT_INCLUDES:=""}
208 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup"
200 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup"
209
201
210 #Packages to exclude from chroot build environment
202 #Packages to exclude from chroot build environment
211 APT_EXCLUDES=${APT_EXCLUDES:=""}
203 APT_EXCLUDES=${APT_EXCLUDES:=""}
212
204
213 # Packages required for bootstrapping
205 # Packages required for bootstrapping
214 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo netselect-apt"
206 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo netselect-apt"
215 MISSING_PACKAGES=""
207 MISSING_PACKAGES=""
216
208
217 # Packages installed for c/c++ build environment in chroot (keep empty)
209 # Packages installed for c/c++ build environment in chroot (keep empty)
218 COMPILER_PACKAGES=""
210 COMPILER_PACKAGES=""
219
211
220 #Check if apt-cacher-ng has its default port open on and set APT_PROXY
212 #Check if apt-cacher-ng has its default port open on and set APT_PROXY
221 if [ -n "$(lsof -i :3142)" ] ; then
213 if [ -n "$(lsof -i :3142)" ] ; then
222 HTTP_PROXY=http://127.0.0.1:3142/
214 HTTP_PROXY=http://127.0.0.1:3142/
223 fi
215 fi
224
216
225 #netselect-apt does not know buster yet
217 #netselect-apt does not know buster yet
226 if [ "$RELEASE" = "buster" ] ; then
218 if [ "$RELEASE" = "buster" ] ; then
227 RLS=testing
219 RLS=testing
228 else
220 else
229 RLS="$RELEASE"
221 RLS="$RELEASE"
230 fi
222 fi
231
223
232 if [ -f "$(pwd)/files/apt/sources.list" ] ; then
224 if [ -f "$(pwd)/files/apt/sources.list" ] ; then
233 rm "$(pwd)/files/apt/sources.list"
225 rm "$(pwd)/files/apt/sources.list"
234 fi
226 fi
235
227
236 if [ "$ENABLE_NONFREE" = true ] ; then
228 if [ "$ENABLE_NONFREE" = true ] ; then
237 netselect-apt --arch "$RELEASE_ARCH" --tests 10 --sources --nonfree --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
229 netselect-apt --arch "$RELEASE_ARCH" --tests 10 --sources --nonfree --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
238 else
230 else
239 netselect-apt --arch "$RELEASE_ARCH" --tests 10 --sources --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
231 netselect-apt --arch "$RELEASE_ARCH" --tests 10 --sources --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
240 fi
232 fi
241
233
242 #sed and cut the result string so we can use it as APT_SERVER
234 #sed and cut the result string so we can use it as APT_SERVER
243 APT_SERVER=$(grep -m 1 http files/apt/sources.list | sed "s|http://| |g" | cut -d ' ' -f 3 | sed 's|/$|''|')
235 APT_SERVER=$(grep -m 1 http files/apt/sources.list | sed "s|http://| |g" | cut -d ' ' -f 3 | sed 's|/$|''|')
244
236
245 #make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
237 #make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
246 if [ -n "$SET_ARCH" ] ; then
238 if [ -n "$SET_ARCH" ] ; then
247 echo "Setting Architecture specific settings"
239 # 64 bit configuration
248 ##################################
249 # 64 bit config
250 ##################################
251 if [ "$SET_ARCH" = 64 ] ; then
240 if [ "$SET_ARCH" = 64 ] ; then
252 # General 64 bit depended settings
241 # General 64 bit depended settings
253 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
242 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
254 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
243 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
255 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
244 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
256
245
257 # Board specific settings
246 # Board specific settings
258 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
247 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
259 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
248 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
260 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
249 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
261 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
250 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
262 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
251 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
263 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
252 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
264 else
253 else
265 echo "error: Only Raspberry PI 3 and 3B+ support 64 bit"
254 echo "error: Only Raspberry PI 3 and 3B+ support 64 bit"
266 exit 1
255 exit 1
267 fi
256 fi
268 fi
257 fi
269
258
270 # 32 bit configuration
259 # 32 bit configuration
271 if [ "$SET_ARCH" = 32 ] ; then
260 if [ "$SET_ARCH" = 32 ] ; then
272 # General 32 bit dependend settings
261 # General 32 bit dependend settings
273 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
262 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
274 KERNEL_ARCH=${KERNEL_ARCH:=arm}
263 KERNEL_ARCH=${KERNEL_ARCH:=arm}
275 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
264 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
276
265
277 # Hardware specific settings
266 # Hardware specific settings
278 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
267 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
279 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
268 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
280 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
269 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
281 RELEASE_ARCH=${RELEASE_ARCH:=armel}
270 RELEASE_ARCH=${RELEASE_ARCH:=armel}
282 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
271 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
283 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
272 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
284 fi
273 fi
285
274
286 # Hardware specific settings
275 # Hardware specific settings
287 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
276 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
288 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
277 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
289 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
278 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
290 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
279 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
291 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
280 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
292 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
281 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
293 fi
282 fi
294 fi
283 fi
295 #SET_ARCH not set
284 #SET_ARCH not set
296 else
285 else
297 echo "error: Please set '32' or '64' as value for SET_ARCH"
286 echo "error: Please set '32' or '64' as value for SET_ARCH"
298 exit 1
287 exit 1
299 fi
288 fi
300 # Device specific configuration and U-Boot configuration
289 # Device specific configuration and U-Boot configuration
301 case "$RPI_MODEL" in
290 case "$RPI_MODEL" in
302 0)
291 0)
303 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
292 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
304 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
293 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
305 ;;
294 ;;
306 1)
295 1)
307 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
296 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
308 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
297 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
309 ;;
298 ;;
310 1P)
299 1P)
311 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
300 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
312 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
301 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
313 ;;
302 ;;
314 2)
303 2)
315 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
304 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
316 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
305 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
317 ;;
306 ;;
318 3)
307 3)
319 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
308 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
320 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
309 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
321 ;;
310 ;;
322 3P)
311 3P)
323 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
312 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
324 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
313 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
325 ;;
314 ;;
326 *)
315 *)
327 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
316 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
328 exit 1
317 exit 1
329 ;;
318 ;;
330 esac
319 esac
331
320
332 #DEBUG off
321 # Prepare date string for default image file name
333 set +x
322 DATE="$(date +%Y-%m-%d)"
323 if [ -z "$KERNEL_BRANCH" ] ; then
324 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
325 else
326 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
327 fi
334
328
335 # Check if the internal wireless interface is supported by the RPi model
329 # Check if the internal wireless interface is supported by the RPi model
336 if [ "$ENABLE_WIRELESS" = true ] ; then
330 if [ "$ENABLE_WIRELESS" = true ] ; then
337 if [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 2 ] ; then
331 if [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 2 ] ; then
338 echo "error: The selected Raspberry Pi model has no internal wireless interface"
332 echo "error: The selected Raspberry Pi model has no internal wireless interface"
339 exit 1
333 exit 1
340 fi
334 fi
341 fi
335 fi
342
336
343 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
337 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
344 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
338 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
345 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
339 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
346 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
340 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
347 exit 1
341 exit 1
348 fi
342 fi
349 fi
343 fi
350
344
351 # Add cmake to compile videocore sources
345 # Add cmake to compile videocore sources
352 if [ "$ENABLE_VIDEOCORE" = true ] ; then
346 if [ "$ENABLE_VIDEOCORE" = true ] ; then
353 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
347 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
354 fi
348 fi
355
349
356 # Add libncurses5 to enable kernel menuconfig
350 # Add libncurses5 to enable kernel menuconfig
357 if [ "$KERNEL_MENUCONFIG" = true ] ; then
351 if [ "$KERNEL_MENUCONFIG" = true ] ; then
358 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
352 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
359 fi
353 fi
360
354
361 # Add ccache compiler cache for (faster) kernel cross (re)compilation
355 # Add ccache compiler cache for (faster) kernel cross (re)compilation
362 if [ "$KERNEL_CCACHE" = true ] ; then
356 if [ "$KERNEL_CCACHE" = true ] ; then
363 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
357 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
364 fi
358 fi
365
359
366 # Add cryptsetup package to enable filesystem encryption
360 # Add cryptsetup package to enable filesystem encryption
367 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
361 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
368 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
362 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
369 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
363 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
370
364
371 if [ -z "$CRYPTFS_PASSWORD" ] ; then
365 if [ -z "$CRYPTFS_PASSWORD" ] ; then
372 echo "error: no password defined (CRYPTFS_PASSWORD)!"
366 echo "error: no password defined (CRYPTFS_PASSWORD)!"
373 exit 1
367 exit 1
374 fi
368 fi
375 ENABLE_INITRAMFS=true
369 ENABLE_INITRAMFS=true
376 fi
370 fi
377
371
378 # Add initramfs generation tools
372 # Add initramfs generation tools
379 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
373 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
380 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
374 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
381 fi
375 fi
382
376
383 # Add device-tree-compiler required for building the U-Boot bootloader
377 # Add device-tree-compiler required for building the U-Boot bootloader
384 if [ "$ENABLE_UBOOT" = true ] ; then
378 if [ "$ENABLE_UBOOT" = true ] ; then
385 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
379 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
386 else
380 else
387 if [ "$ENABLE_UBOOTUSB" = true ] ; then
381 if [ "$ENABLE_UBOOTUSB" = true ] ; then
388 echo "error: Enabling UBOOTUSB requires u-boot to be enabled"
382 echo "error: Enabling UBOOTUSB requires u-boot to be enabled"
389 exit 1
383 exit 1
390 fi
384 fi
391 fi
385 fi
392
386
393 # Check if root SSH (v2) public key file exists
387 # Check if root SSH (v2) public key file exists
394 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
388 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
395 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
389 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
396 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
390 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
397 exit 1
391 exit 1
398 fi
392 fi
399 fi
393 fi
400
394
401 # Check if $USER_NAME SSH (v2) public key file exists
395 # Check if $USER_NAME SSH (v2) public key file exists
402 if [ -n "$SSH_USER_PUB_KEY" ] ; then
396 if [ -n "$SSH_USER_PUB_KEY" ] ; then
403 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
397 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
404 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
398 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
405 exit 1
399 exit 1
406 fi
400 fi
407 fi
401 fi
408
402
409 # Check if all required packages are installed on the build system
403 # Check if all required packages are installed on the build system
410 for package in $REQUIRED_PACKAGES ; do
404 for package in $REQUIRED_PACKAGES ; do
411 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
405 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
412 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
406 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
413 fi
407 fi
414 done
408 done
415
409
416 # If there are missing packages ask confirmation for install, or exit
410 # If there are missing packages ask confirmation for install, or exit
417 if [ -n "$MISSING_PACKAGES" ] ; then
411 if [ -n "$MISSING_PACKAGES" ] ; then
418 echo "the following packages needed by this script are not installed:"
412 echo "the following packages needed by this script are not installed:"
419 echo "$MISSING_PACKAGES"
413 echo "$MISSING_PACKAGES"
420
414
421 printf "\ndo you want to install the missing packages right now? [y/n] "
415 printf "\ndo you want to install the missing packages right now? [y/n] "
422 read -r confirm
416 read -r confirm
423 [ "$confirm" != "y" ] && exit 1
417 [ "$confirm" != "y" ] && exit 1
424
418
425 # Make sure all missing required packages are installed
419 # Make sure all missing required packages are installed
426 apt-get -qq -y install "${MISSING_PACKAGES}"
420 apt-get -qq -y install "${MISSING_PACKAGES}"
427 fi
421 fi
428
422
429 # Check if ./bootstrap.d directory exists
423 # Check if ./bootstrap.d directory exists
430 if [ ! -d "./bootstrap.d/" ] ; then
424 if [ ! -d "./bootstrap.d/" ] ; then
431 echo "error: './bootstrap.d' required directory not found!"
425 echo "error: './bootstrap.d' required directory not found!"
432 exit 1
426 exit 1
433 fi
427 fi
434
428
435 # Check if ./files directory exists
429 # Check if ./files directory exists
436 if [ ! -d "./files/" ] ; then
430 if [ ! -d "./files/" ] ; then
437 echo "error: './files' required directory not found!"
431 echo "error: './files' required directory not found!"
438 exit 1
432 exit 1
439 fi
433 fi
440
434
441 # Check if specified KERNELSRC_DIR directory exists
435 # Check if specified KERNELSRC_DIR directory exists
442 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
436 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
443 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
437 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
444 exit 1
438 exit 1
445 fi
439 fi
446
440
447 # Check if specified UBOOTSRC_DIR directory exists
441 # Check if specified UBOOTSRC_DIR directory exists
448 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
442 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
449 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
443 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
450 exit 1
444 exit 1
451 fi
445 fi
452
446
453 # Check if specified VIDEOCORESRC_DIR directory exists
447 # Check if specified VIDEOCORESRC_DIR directory exists
454 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
448 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
455 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
449 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
456 exit 1
450 exit 1
457 fi
451 fi
458
452
459 # Check if specified FBTURBOSRC_DIR directory exists
453 # Check if specified FBTURBOSRC_DIR directory exists
460 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
454 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
461 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
455 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
462 exit 1
456 exit 1
463 fi
457 fi
464
458
465 # Check if specified CHROOT_SCRIPTS directory exists
459 # Check if specified CHROOT_SCRIPTS directory exists
466 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
460 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
467 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
461 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
468 exit 1
462 exit 1
469 fi
463 fi
470
464
471 # Check if specified device mapping already exists (will be used by cryptsetup)
465 # Check if specified device mapping already exists (will be used by cryptsetup)
472 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
466 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
473 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
467 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
474 exit 1
468 exit 1
475 fi
469 fi
476
470
477 # Don't clobber an old build
471 # Don't clobber an old build
478 if [ -e "$BUILDDIR" ] ; then
472 if [ -e "$BUILDDIR" ] ; then
479 echo "error: directory ${BUILDDIR} already exists, not proceeding"
473 echo "error: directory ${BUILDDIR} already exists, not proceeding"
480 exit 1
474 exit 1
481 fi
475 fi
482
476
483 # Setup chroot directory
477 # Setup chroot directory
484 mkdir -p "${R}"
478 mkdir -p "${R}"
485
479
486 # Check if build directory has enough of free disk space >512MB
480 # Check if build directory has enough of free disk space >512MB
487 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
481 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
488 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
482 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
489 exit 1
483 exit 1
490 fi
484 fi
491
485
492 set -x
486 set -x
493
487
494 # Call "cleanup" function on various signals and errors
488 # Call "cleanup" function on various signals and errors
495 trap cleanup 0 1 2 3 6
489 trap cleanup 0 1 2 3 6
496
490
497 # Add required packages for the minbase installation
491 # Add required packages for the minbase installation
498 if [ "$ENABLE_MINBASE" = true ] ; then
492 if [ "$ENABLE_MINBASE" = true ] ; then
499 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
493 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
500 fi
494 fi
501
495
502 # Add parted package, required to get partprobe utility
496 # Add parted package, required to get partprobe utility
503 if [ "$EXPANDROOT" = true ] ; then
497 if [ "$EXPANDROOT" = true ] ; then
504 APT_INCLUDES="${APT_INCLUDES},parted"
498 APT_INCLUDES="${APT_INCLUDES},parted"
505 fi
499 fi
506
500
507 # Add dbus package, recommended if using systemd
501 # Add dbus package, recommended if using systemd
508 if [ "$ENABLE_DBUS" = true ] ; then
502 if [ "$ENABLE_DBUS" = true ] ; then
509 APT_INCLUDES="${APT_INCLUDES},dbus"
503 APT_INCLUDES="${APT_INCLUDES},dbus"
510 fi
504 fi
511
505
512 # Add iptables IPv4/IPv6 package
506 # Add iptables IPv4/IPv6 package
513 if [ "$ENABLE_IPTABLES" = true ] ; then
507 if [ "$ENABLE_IPTABLES" = true ] ; then
514 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
508 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
515 fi
509 fi
516
510
517 # Add openssh server package
511 # Add openssh server package
518 if [ "$ENABLE_SSHD" = true ] ; then
512 if [ "$ENABLE_SSHD" = true ] ; then
519 APT_INCLUDES="${APT_INCLUDES},openssh-server"
513 APT_INCLUDES="${APT_INCLUDES},openssh-server"
520 fi
514 fi
521
515
522 # Add alsa-utils package
516 # Add alsa-utils package
523 if [ "$ENABLE_SOUND" = true ] ; then
517 if [ "$ENABLE_SOUND" = true ] ; then
524 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
518 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
525 fi
519 fi
526
520
527 # Add rng-tools package
521 # Add rng-tools package
528 if [ "$ENABLE_HWRANDOM" = true ] ; then
522 if [ "$ENABLE_HWRANDOM" = true ] ; then
529 APT_INCLUDES="${APT_INCLUDES},rng-tools"
523 APT_INCLUDES="${APT_INCLUDES},rng-tools"
530 fi
524 fi
531
525
532 # Add fbturbo video driver
526 # Add fbturbo video driver
533 if [ "$ENABLE_FBTURBO" = true ] ; then
527 if [ "$ENABLE_FBTURBO" = true ] ; then
534 # Enable xorg package dependencies
528 # Enable xorg package dependencies
535 ENABLE_XORG=true
529 ENABLE_XORG=true
536 fi
530 fi
537
531
538 # Add user defined window manager package
532 # Add user defined window manager package
539 if [ -n "$ENABLE_WM" ] ; then
533 if [ -n "$ENABLE_WM" ] ; then
540 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
534 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
541
535
542 # Enable xorg package dependencies
536 # Enable xorg package dependencies
543 ENABLE_XORG=true
537 ENABLE_XORG=true
544 fi
538 fi
545
539
546 # Add xorg package
540 # Add xorg package
547 if [ "$ENABLE_XORG" = true ] ; then
541 if [ "$ENABLE_XORG" = true ] ; then
548 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
542 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
549 fi
543 fi
550
544
551 # Replace selected packages with smaller clones
545 # Replace selected packages with smaller clones
552 if [ "$ENABLE_REDUCE" = true ] ; then
546 if [ "$ENABLE_REDUCE" = true ] ; then
553 # Add levee package instead of vim-tiny
547 # Add levee package instead of vim-tiny
554 if [ "$REDUCE_VIM" = true ] ; then
548 if [ "$REDUCE_VIM" = true ] ; then
555 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
549 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
556 fi
550 fi
557
551
558 # Add dropbear package instead of openssh-server
552 # Add dropbear package instead of openssh-server
559 if [ "$REDUCE_SSHD" = true ] ; then
553 if [ "$REDUCE_SSHD" = true ] ; then
560 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
554 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
561 fi
555 fi
562 fi
556 fi
563
557
564 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
558 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
565 if [ "$ENABLE_SYSVINIT" = false ] ; then
559 if [ "$ENABLE_SYSVINIT" = false ] ; then
566 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
560 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
567 fi
561 fi
568
562
569 # Configure kernel sources if no KERNELSRC_DIR
563 # Configure kernel sources if no KERNELSRC_DIR
570 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
564 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
571 KERNELSRC_CONFIG=true
565 KERNELSRC_CONFIG=true
572 fi
566 fi
573
567
574 # Configure reduced kernel
568 # Configure reduced kernel
575 if [ "$KERNEL_REDUCE" = true ] ; then
569 if [ "$KERNEL_REDUCE" = true ] ; then
576 KERNELSRC_CONFIG=false
570 KERNELSRC_CONFIG=false
577 fi
571 fi
578
572
579 # Configure qemu compatible kernel
573 # Configure qemu compatible kernel
580 if [ "$ENABLE_QEMU" = true ] ; then
574 if [ "$ENABLE_QEMU" = true ] ; then
581 DTB_FILE=vexpress-v2p-ca15_a7.dtb
575 DTB_FILE=vexpress-v2p-ca15_a7.dtb
582 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
576 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
583 KERNEL_DEFCONFIG="vexpress_defconfig"
577 KERNEL_DEFCONFIG="vexpress_defconfig"
584 if [ "$KERNEL_MENUCONFIG" = false ] ; then
578 if [ "$KERNEL_MENUCONFIG" = false ] ; then
585 KERNEL_OLDDEFCONFIG=true
579 KERNEL_OLDDEFCONFIG=true
586 fi
580 fi
587 fi
581 fi
588
582
589 # Execute bootstrap scripts
583 # Execute bootstrap scripts
590 for SCRIPT in bootstrap.d/*.sh; do
584 for SCRIPT in bootstrap.d/*.sh; do
591 head -n 3 "$SCRIPT"
585 head -n 3 "$SCRIPT"
592 . "$SCRIPT"
586 . "$SCRIPT"
593 done
587 done
594
588
595 ## Execute custom bootstrap scripts
589 ## Execute custom bootstrap scripts
596 if [ -d "custom.d" ] ; then
590 if [ -d "custom.d" ] ; then
597 for SCRIPT in custom.d/*.sh; do
591 for SCRIPT in custom.d/*.sh; do
598 . "$SCRIPT"
592 . "$SCRIPT"
599 done
593 done
600 fi
594 fi
601
595
602 # Execute custom scripts inside the chroot
596 # Execute custom scripts inside the chroot
603 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
597 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
604 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
598 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
605 chroot_exec /bin/bash -x <<'EOF'
599 chroot_exec /bin/bash -x <<'EOF'
606 for SCRIPT in /chroot_scripts/* ; do
600 for SCRIPT in /chroot_scripts/* ; do
607 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
601 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
608 $SCRIPT
602 $SCRIPT
609 fi
603 fi
610 done
604 done
611 EOF
605 EOF
612 rm -rf "${R}/chroot_scripts"
606 rm -rf "${R}/chroot_scripts"
613 fi
607 fi
614
608
615 # Remove c/c++ build environment from the chroot
609 # Remove c/c++ build environment from the chroot
616 chroot_remove_cc
610 chroot_remove_cc
617
611
618 # Generate required machine-id
612 # Generate required machine-id
619 MACHINE_ID=$(dbus-uuidgen)
613 MACHINE_ID=$(dbus-uuidgen)
620 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
614 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
621 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
615 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
622
616
623 # APT Cleanup
617 # APT Cleanup
624 chroot_exec apt-get -y clean
618 chroot_exec apt-get -y clean
625 chroot_exec apt-get -y autoclean
619 chroot_exec apt-get -y autoclean
626 chroot_exec apt-get -y autoremove
620 chroot_exec apt-get -y autoremove
627
621
628 # Unmount mounted filesystems
622 # Unmount mounted filesystems
629 umount -l "${R}/proc"
623 umount -l "${R}/proc"
630 umount -l "${R}/sys"
624 umount -l "${R}/sys"
631
625
632 # Clean up directories
626 # Clean up directories
633 rm -rf "${R}/run/*"
627 rm -rf "${R}/run/*"
634 rm -rf "${R}/tmp/*"
628 rm -rf "${R}/tmp/*"
635
629
636 # Clean up files
630 # Clean up files
637 rm -f "${ETC_DIR}/ssh/ssh_host_*"
631 rm -f "${ETC_DIR}/ssh/ssh_host_*"
638 rm -f "${ETC_DIR}/dropbear/dropbear_*"
632 rm -f "${ETC_DIR}/dropbear/dropbear_*"
639 rm -f "${ETC_DIR}/apt/sources.list.save"
633 rm -f "${ETC_DIR}/apt/sources.list.save"
640 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
634 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
641 rm -f "${ETC_DIR}/*-"
635 rm -f "${ETC_DIR}/*-"
642 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
636 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
643 rm -f "${ETC_DIR}/resolv.conf"
637 rm -f "${ETC_DIR}/resolv.conf"
644 rm -f "${R}/root/.bash_history"
638 rm -f "${R}/root/.bash_history"
645 rm -f "${R}/var/lib/urandom/random-seed"
639 rm -f "${R}/var/lib/urandom/random-seed"
646 rm -f "${R}/initrd.img"
640 rm -f "${R}/initrd.img"
647 rm -f "${R}/vmlinuz"
641 rm -f "${R}/vmlinuz"
648 rm -f "${R}${QEMU_BINARY}"
642 rm -f "${R}${QEMU_BINARY}"
649
643
650 if [ "$ENABLE_QEMU" = true ] ; then
644 if [ "$ENABLE_QEMU" = true ] ; then
651 # Setup QEMU directory
645 # Setup QEMU directory
652 mkdir "${BASEDIR}/qemu"
646 mkdir "${BASEDIR}/qemu"
653
647
654 # Copy kernel image to QEMU directory
648 # Copy kernel image to QEMU directory
655 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
649 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
656
650
657 # Copy kernel config to QEMU directory
651 # Copy kernel config to QEMU directory
658 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
652 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
659
653
660 # Copy kernel dtbs to QEMU directory
654 # Copy kernel dtbs to QEMU directory
661 for dtb in "${BOOT_DIR}/"*.dtb ; do
655 for dtb in "${BOOT_DIR}/"*.dtb ; do
662 if [ -f "${dtb}" ] ; then
656 if [ -f "${dtb}" ] ; then
663 install_readonly "${dtb}" "${BASEDIR}/qemu/"
657 install_readonly "${dtb}" "${BASEDIR}/qemu/"
664 fi
658 fi
665 done
659 done
666
660
667 # Copy kernel overlays to QEMU directory
661 # Copy kernel overlays to QEMU directory
668 if [ -d "${BOOT_DIR}/overlays" ] ; then
662 if [ -d "${BOOT_DIR}/overlays" ] ; then
669 # Setup overlays dtbs directory
663 # Setup overlays dtbs directory
670 mkdir "${BASEDIR}/qemu/overlays"
664 mkdir "${BASEDIR}/qemu/overlays"
671
665
672 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
666 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
673 if [ -f "${dtb}" ] ; then
667 if [ -f "${dtb}" ] ; then
674 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
668 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
675 fi
669 fi
676 done
670 done
677 fi
671 fi
678
672
679 # Copy u-boot files to QEMU directory
673 # Copy u-boot files to QEMU directory
680 if [ "$ENABLE_UBOOT" = true ] ; then
674 if [ "$ENABLE_UBOOT" = true ] ; then
681 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
675 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
682 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
676 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
683 fi
677 fi
684 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
678 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
685 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
679 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
686 fi
680 fi
687 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
681 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
688 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
682 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
689 fi
683 fi
690 fi
684 fi
691
685
692 # Copy initramfs to QEMU directory
686 # Copy initramfs to QEMU directory
693 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
687 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
694 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
688 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
695 fi
689 fi
696 fi
690 fi
697
691
698 # Calculate size of the chroot directory in KB
692 # Calculate size of the chroot directory in KB
699 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
693 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
700
694
701 # Calculate the amount of needed 512 Byte sectors
695 # Calculate the amount of needed 512 Byte sectors
702 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
696 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
703 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
697 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
704 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
698 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
705
699
706 # The root partition is EXT4
700 # The root partition is EXT4
707 # This means more space than the actual used space of the chroot is used.
701 # This means more space than the actual used space of the chroot is used.
708 # As overhead for journaling and reserved blocks 35% are added.
702 # As overhead for journaling and reserved blocks 35% are added.
709 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
703 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
710
704
711 # Calculate required image size in 512 Byte sectors
705 # Calculate required image size in 512 Byte sectors
712 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
706 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
713
707
714 # Prepare image file
708 # Prepare image file
715 if [ "$ENABLE_SPLITFS" = true ] ; then
709 if [ "$ENABLE_SPLITFS" = true ] ; then
716 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
710 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
717 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
711 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
718 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
712 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
719 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
713 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
720
714
721 # Write firmware/boot partition tables
715 # Write firmware/boot partition tables
722 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
716 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
723 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
717 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
724 EOM
718 EOM
725
719
726 # Write root partition table
720 # Write root partition table
727 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
721 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
728 ${TABLE_SECTORS},${ROOT_SECTORS},83
722 ${TABLE_SECTORS},${ROOT_SECTORS},83
729 EOM
723 EOM
730
724
731 # Setup temporary loop devices
725 # Setup temporary loop devices
732 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
726 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
733 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
727 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
734 else # ENABLE_SPLITFS=false
728 else # ENABLE_SPLITFS=false
735 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
729 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
736 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
730 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
737
731
738 # Write partition table
732 # Write partition table
739 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
733 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
740 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
734 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
741 ${ROOT_OFFSET},${ROOT_SECTORS},83
735 ${ROOT_OFFSET},${ROOT_SECTORS},83
742 EOM
736 EOM
743
737
744 # Setup temporary loop devices
738 # Setup temporary loop devices
745 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
739 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
746 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
740 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
747 fi
741 fi
748
742
749 if [ "$ENABLE_CRYPTFS" = true ] ; then
743 if [ "$ENABLE_CRYPTFS" = true ] ; then
750 # Create dummy ext4 fs
744 # Create dummy ext4 fs
751 mkfs.ext4 "$ROOT_LOOP"
745 mkfs.ext4 "$ROOT_LOOP"
752
746
753 # Setup password keyfile
747 # Setup password keyfile
754 touch .password
748 touch .password
755 chmod 600 .password
749 chmod 600 .password
756 echo -n ${CRYPTFS_PASSWORD} > .password
750 echo -n ${CRYPTFS_PASSWORD} > .password
757
751
758 # Initialize encrypted partition
752 # Initialize encrypted partition
759 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
753 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
760
754
761 # Open encrypted partition and setup mapping
755 # Open encrypted partition and setup mapping
762 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
756 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
763
757
764 # Secure delete password keyfile
758 # Secure delete password keyfile
765 shred -zu .password
759 shred -zu .password
766
760
767 # Update temporary loop device
761 # Update temporary loop device
768 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
762 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
769
763
770 # Wipe encrypted partition (encryption cipher is used for randomness)
764 # Wipe encrypted partition (encryption cipher is used for randomness)
771 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
765 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
772 fi
766 fi
773
767
774 # Build filesystems
768 # Build filesystems
775 mkfs.vfat "$FRMW_LOOP"
769 mkfs.vfat "$FRMW_LOOP"
776 mkfs.ext4 "$ROOT_LOOP"
770 mkfs.ext4 "$ROOT_LOOP"
777
771
778 # Mount the temporary loop devices
772 # Mount the temporary loop devices
779 mkdir -p "$BUILDDIR/mount"
773 mkdir -p "$BUILDDIR/mount"
780 mount "$ROOT_LOOP" "$BUILDDIR/mount"
774 mount "$ROOT_LOOP" "$BUILDDIR/mount"
781
775
782 mkdir -p "$BUILDDIR/mount/boot/firmware"
776 mkdir -p "$BUILDDIR/mount/boot/firmware"
783 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
777 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
784
778
785 # Copy all files from the chroot to the loop device mount point directory
779 # Copy all files from the chroot to the loop device mount point directory
786 rsync -a "${R}/" "$BUILDDIR/mount/"
780 rsync -a "${R}/" "$BUILDDIR/mount/"
787
781
788 # Unmount all temporary loop devices and mount points
782 # Unmount all temporary loop devices and mount points
789 cleanup
783 cleanup
790
784
791 # Create block map file(s) of image(s)
785 # Create block map file(s) of image(s)
792 if [ "$ENABLE_SPLITFS" = true ] ; then
786 if [ "$ENABLE_SPLITFS" = true ] ; then
793 # Create block map files for "bmaptool"
787 # Create block map files for "bmaptool"
794 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
788 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
795 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
789 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
796
790
797 # Image was successfully created
791 # Image was successfully created
798 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
792 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
799 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
793 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
800 else
794 else
801 # Create block map file for "bmaptool"
795 # Create block map file for "bmaptool"
802 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
796 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
803
797
804 # Image was successfully created
798 # Image was successfully created
805 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
799 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
806
800
807 # Create qemu qcow2 image
801 # Create qemu qcow2 image
808 if [ "$ENABLE_QEMU" = true ] ; then
802 if [ "$ENABLE_QEMU" = true ] ; then
809 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
803 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
810 QEMU_SIZE=16G
804 QEMU_SIZE=16G
811
805
812 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
806 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
813 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
807 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
814
808
815 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
809 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
816 fi
810 fi
817 fi
811 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant